// CPPP 2.0 - Comptition en Percolation de Premier Passage

// Olivier Garet, version du 24 dcembre 2003 

#include <fstream>
#include <queue>
#include <math.h>

#include "argstream.h"

#include "rvb.cpp"
#include "reseau.cpp"

#include "reseau_spec.h"

#include  fichier_classe_reseau_choisi 
#include  fichier_rvb_reseau_choisi
#include "file.h"
using namespace std;

float proba=0.5;
float p=1;
float q=1;
int temps_maxi=3;
int temps_mini=1;
int ecart=1;
//int facteur[3]={1,1,1};
float f_type[3]={1,1,1};
int f_max[3]={1,1,1};
int f_min[3]={1,1,1};
// gnration des temps de passage alatoires, ouverture des artes

int temps(int couleur)
{  float q;
 q = float(random())/float(RAND_MAX);
if (q<proba) { return f_max[couleur]; } else { return f_min[couleur];}
}

bool passe(int particule, int direction)
{return ((random())/float(RAND_MAX)<f_type[particule]);}

int main(int argc,char** argv)
{    
  coloriage *bon;
  int i,j,adresse,n_heure;
  reseau_choisi_point le_p,voisin;
  

  int temps_max=0;
  int couleur=2; 
  int nouvelle_couleur; 
  bool sortie_couleur=0,sortie_temps=0,sortie_diff=0;
  bool pnm=0;
  bool fond=0;
  bool arret;
  bool help; 
  char chaine[256];
  unsigned int germe=1;
  string titre="competition.pnm";
 ofstream fichier_out; // Fichier en criture

 // for(int j =0; j <argc; j++) {cout << argv[j]<<" ";};
 // cout << endl;

argstream as(argc,argv);

as>>parameter('g',"germe",germe,"germe du gnrateur alatoire",false)
>>parameter('a',"alea",proba,"Proba temps de passage maximal",false)
>>parameter('c',"couleur",couleur,"couleur de la deuxime particule",false)
>>parameter('p',"proba",p,"Proba de passage d'une arte",false);
 f_type[1]=p;
 f_type[2]=p;
as>>parameter('q',"p1",f_type[1],"Proba de passage arete par type 1",false)
>>parameter('r',"p2",f_type[2],"Proba de passage arete par type 2",false)
>>parameter('d',"demi",demi,"taille du demi ecran",false)
>>parameter('M',"max",temps_maxi,"temps de passage maximal",false)
  >>parameter('m',"min",temps_mini,"temps de passage minimal",false);
 f_min[1]=temps_mini; f_min[2]=temps_mini;
 f_max[1]=temps_maxi; f_max[2]=temps_maxi;
as>>parameter('N',"max1",f_max[1],"temps de passage maximal pour le type 1",false)
>>parameter('n',"min1",f_min[1],"temps de passage minimal pour le type 1",false)
>>parameter('O',"max2",f_max[2],"temps de passage maximal pour le type 2",false)
>>parameter('o',"min2",f_min[2],"temps de passage minimal pour le type 2",false)
//>>parameter('r',"r1",facteur[1],"Facteur de ralentissement du type 1",false)
//>>parameter('s',"r2",facteur[2],"Facteur de ralentissement du type 2",false)
>>parameter('e',"ecart",ecart,"Ecart entre les sources",false)
>>parameter('f',"fichier",titre,"fichier de sortie",false)
  // >>option ('P',"PN",pnm,"Image dans un fichier pnm")
 >>option ('F',"fond",fond,"Fond en blanc")
  // >>option ('C',"sortie_couleur",sortie_couleur,"Couleur finale dans le fichier de sortie")
  // >>option ('T',"sortie_temps",sortie_temps,"Temps final dans le fichier de sortie")
  //>>option ('D',"sortie_diff",sortie_diff,"Diffrentiel de temps dans le fichier de sortie")
>>option('h',"help",help,"Affiche cette aide");

if (help) 
{ 
cout <<"CPPP 2.0"<< endl;
cout <<as.usage()<<endl; 
}

else
  {
// tranche si les options sont incompatibles

 if (!( pnm ^ ( sortie_couleur | sortie_temps | sortie_diff)))
   {sortie_couleur=0;
   sortie_temps=0;
   sortie_diff=0;
   pnm=1;
   }


  cote=calcul_cote(demi);
  srandom(germe);

  etat g;
  //    etat  *grille;
  //grille=new etat[cote*cote];

  ddreseau_choisi Ma_grille;
  Ma_grille.mem(cote);

    // Construit deux objets et les mets sur la file

 depose(0,point_un,1);
 depose(0,point_deux,couleur);
 // cout << "debut" << endl;
    // Rcupre les lments par ordre de priorit :
 do
      { 
        le_p= pq.top().p;
	arret=(le_p.bordure());
 if (!arret){
      adresse=le_p.adresse();
      if (Ma_grille.get_couleur(adresse)==0)
      {       temps_max=pq.top().heure;
      nouvelle_couleur=pq.top().couleur;
      g=etat(temps_max,nouvelle_couleur);
      Ma_grille.set(adresse,g);
 for(int numero_voisin =0; numero_voisin<ordre; numero_voisin++)
   { if (passe(nouvelle_couleur,numero_voisin))
      {
        n_heure=g.heure+temps(nouvelle_couleur);
        voisin=le_p;
        voisin.deplace(numero_voisin);
        if  (Ma_grille.get_heure(voisin.adresse())>n_heure)  
         { Ma_grille.set_heure(voisin.adresse(),n_heure); 
          depose(n_heure,voisin,nouvelle_couleur);
         };
	 };
   };

	 }; pq.pop();
 };
      }   
while (!(pq.empty() | arret));



 // RVB_class mon_RVB;

 // mon_RVB.RVB_mem(temps_max);

//  On met "0" pour les points qui n'ont pas t atteints ;
// temps_max serait est une autre possibilit

 // if (fond) {Ma_grille.RVB_pref(temps_max-1);}
 //  else {Ma_grille.RVB_pref(0);}

  Ma_grille.RVB_mem(temps_max);
 if (fond) {Ma_grille.set_convert(temps_max-1,INT_MAX);}
  else {Ma_grille.set_convert(0,INT_MAX);}

// if (fond) {mon_RVB.set_convert(temps_max-1,INT_MAX);}
//  else {mon_RVB.set_convert(0,INT_MAX);}

// calcul des couleurs RVB associes aux diffrents temps de passage

// On ouvre le fichier en mode criture "ios::out"

strncpy(chaine, titre.c_str(), 255);
fichier_out.open(chaine, ios::out);

// on crit ce que l'utilisateur a demand

 cout << float(temps_max)/float(demi) << endl;

 if (pnm) {
   fichier_out << "P6" << endl;
   fichier_out << "# Fichier gnr par CPPP 2.0" << endl;
   fichier_out << "#";
   for(int j =0; j <argc; j++) {fichier_out << argv[j]<<" ";};
   fichier_out << endl;
   fichier_out  << "# Proba de passage d'une arte : " << p << endl;
   fichier_out  << "# Proba de la valeur dpassant 1 : " << proba << endl;
   fichier_out  << "# Temps de passage maximal : " << temps_maxi << endl;
   fichier_out  << "# Temps de passage minimal : " << temps_mini << endl;
   fichier_out  << "# Germe : " << germe << endl;
   fichier_out  << "# Taille du demi-cran : " << demi << endl;
   fichier_out << cote << " " << cote << endl << "255" << endl;
 //for(int i =0; i <cote*cote; i++)
 //  fichier_out << mon_RVB.get_RVB(Ma_grille.get_heure(i),Ma_grille.get_couleur(i));

  fichier_out << Ma_grille; 

 }
 /*
 if (sortie_couleur) {
 fichier_out << " C=[" << endl ;
for(int j =0; j <cote; j++)
  { for(int i =0; i <cote; i++)
    fichier_out << grille[j*cote+i].couleur << " ";
  fichier_out << ";" << endl; }
 fichier_out << "];" << endl ;
 }

 if (sortie_diff) {
 fichier_out << " D=[" << endl ;
for(int j =0; j <cote; j++)
  { for(int i =0; i <cote-1; i++)
    fichier_out << grille[j*cote+i].heure-grille[j*cote+i+1].heure << " ";
  fichier_out << ";" << endl; }
 fichier_out << "];" << endl ;
 }

 if (sortie_temps) {
 fichier_out << " T=[" << endl ;
for(int j =0; j <cote; j++)
  { for(int i =0; i <cote; i++)
    fichier_out << grille[j*cote+i].heure << " ";
  fichier_out << ";" << endl; }
 fichier_out << "];" << endl ;
 }
 */
// On ferme le fichier
 fichier_out.close();
 // cout << "fini" << endl;

// On fait le mnage

// delete[] grille;

  };
    return 0;
 
}







