// XCPPP 2.0 - Comptition en Percolation de Premier Passage

// Olivier Garet, version du 24 dcembre 2003 


/* pour compiler:             */
/* g++ -O -L/usr/X11R6/lib xcpp.cc -lX11 -lm  -o xcpp */


// Librairies standard
#include <fstream>
#include <queue>

// Librairies X11
# include <X11/Xlib.h>
# include <X11/Xutil.h>


# include <math.h>

// Librairie agrstream de Xavier Dcoret
#include "argstream.h"

// Librairies cppp
#include "rvb.cpp"
#include "reseau.cpp"
#include "lattice_spec.h"
#include  fichier_classe_reseau_choisi
#include  fichier_rvb_reseau_choisi
#include "file.h"

using namespace std;


int facteur[3]={1,1,1};

float proba=0.5;
float p=1;
int couleur=2; 
int vitesse=3;
bool arret;
int temps_max;
bool sortie_couleur=0,sortie_temps=0,sortie_diff=0;
bool pnm=0;
bool fond=0;
unsigned int germe=1;
char chaine[256];
  
string titre="competition";

int ecart=200;
int hbar=0;

ddreseau_choisi Ma_grille;

// gnration des temps de passage alatoires, ouverture des artes

int temps(int couleur)
{  float q;
 q = float(random())/float(RAND_MAX);
if (q<proba) { return vitesse*facteur[couleur]; } else { return facteur[couleur];}
}

bool passe(int i)
{ return ((random())/float(RAND_MAX)<p); }

struct timeval timeout;               /* timer for speed control           */

/* dimensions for buttons */
# define BUTTONWIDTH 84
# define BUTTONHEIGHT 18

int paused=0;             /* is the system paused?          */

int speed=0; /* updating delay proportional to speed; between 0 and 10   */
int delay=0; /* counter for implementing speed control */

# define line(x1,y1,x2,y2) XDrawLine(display,window,gc,x1,y1,x2,y2)
# define point(x1,y1) XDrawPoint(display,window,gc,x1,y1)
# define color(i) XSetForeground(display,gc,translate[i])

/* various window stuff */
Display *display;
int screen;
static char *progname;
Window window,quitbutton,pausebutton,restartbutton,savebutton,distancebutton,probabutton;

XColor xcolor,colorcell;
Colormap cmap;
GC gc;
int windowwidth,windowheight,playwidth,playheight;
XFontStruct *font=NULL;
int font_height,font_width;
XSizeHints size_hints;
int darkcolor,lightcolor,black,white;
long translate[256];    /* for converting colors   */

void dessine()
{ int i,j,adresse;
 for (i=-demi;i<demi;i++)
  for (j=-demi;j<demi;j++)
    {
 adresse=(j+demi)*cote+i+demi;
 color(Ma_grille.get_couleur(adresse));
 point(i+demi,j+demi);
    }
}
  

void etape()
{ int adresse,n_heure,nouvelle_couleur;
 etat g;
 reseau_choisi_point le_p,voisin;

if (!(pq.empty() | arret))
  {
        le_p= pq.top().p;
	arret=(le_p.bordure());
 if (!arret){
      adresse=le_p.adresse();
      if (Ma_grille.get_couleur(adresse)==0)
      {       temps_max=pq.top().heure;
      nouvelle_couleur=pq.top().couleur;
      color(nouvelle_couleur);
      point(adresse%cote,adresse/cote);
      g=etat(temps_max,nouvelle_couleur);
      Ma_grille.set(adresse,g);
 for(int numero_voisin =0; numero_voisin<ordre; numero_voisin++)
   { if (passe(numero_voisin))
      {
        n_heure=g.heure+temps(nouvelle_couleur);
        voisin=le_p;
        voisin.deplace(numero_voisin);
        if  (Ma_grille.get_heure(voisin.adresse())>n_heure)  
         { Ma_grille.set_heure(voisin.adresse(),n_heure); 
          depose(n_heure,voisin,nouvelle_couleur);
         };
	 };
   };
	 }; pq.pop(); 
      };
}
}

void initialisation()
{ 
 arret=0;
 while (!pq.empty()) {pq.pop();};
 temps_max=0;
 // Dpose les deux points de dpart  sur la file
 depose(0,point_un,1);
 depose(0,point_deux,couleur);
}

void recommence()
{ 
initialisation();
Ma_grille.efface();
dessine();
}

void drawbutton(Window buttonwindow,int xoffset,int yoffset,int xsize,int ysize,char *text,int state)
     /*Window buttonwindow; */
/*int xoffset,yoffset,xsize,ysize,state;
  char * text; */
/* Draw a button in buttonwindow of specified dimensions with text
   centered.  Color of button determined by sign of "state", 
   size of border determined by magnitude. 
   I don't need no stinking tookit. */
{int textlength,i,j;
 int cdark,clight,cup,cdown;
 int cleft,cright,cbutton,ctext;
 cup=lightcolor;
 cdown=darkcolor;
 cdark=black;
 clight=white;
 if (state<0)
  {cbutton=cdown;
   ctext=clight;
   cleft=cdark;
   cright=clight;
  } 
 else
  {cbutton=cup;
   ctext=cdark;
   cleft=clight;
   cright=cdark;
  }
 j=abs(state); /* width for button borders */
 XSetForeground(display,gc,cbutton);  
 XFillRectangle(display,buttonwindow,gc,xoffset+j,yoffset+j,
        xsize-2*j,ysize-2*j);
 XSetForeground(display,gc,cleft);
 XFillRectangle(display,buttonwindow,gc,xoffset,yoffset,xsize,j);
 XFillRectangle(display,buttonwindow,gc,xoffset,yoffset,j,ysize);
 XSetForeground(display,gc,cright);
 for (i=0;i<j;i++) 
  {XDrawLine(display,buttonwindow,gc,
     xoffset+i,yoffset+ysize-i-1,xoffset+xsize-i-1,yoffset+ysize-i-1);
   XDrawLine(display,buttonwindow,gc,
     xoffset+xsize-i-1,yoffset+i,xoffset+xsize-i-1,yoffset+ysize-i-1);
  }
 if (NULL!=text)
   {textlength=strlen(text);
    XSetForeground(display,gc,ctext);
    XDrawString(display,buttonwindow,gc,
          xoffset+(xsize-textlength*font_width)/2,
          yoffset+(ysize+font_height)/2-2,
          text,textlength);
   }
 XSetForeground(display,gc,black);
 return;
}


void repaint()  /* this fixes the window up whenever it is uncovered */
{color(9);
 drawbutton(pausebutton,  0,0,BUTTONWIDTH,BUTTONHEIGHT,"pause",  2-4*paused);
  drawbutton(quitbutton,   0,0,BUTTONWIDTH,BUTTONHEIGHT,"quit",   2);
 drawbutton(restartbutton,   0,0,BUTTONWIDTH,BUTTONHEIGHT,"restart",   2);
 drawbutton(savebutton,   0,0,BUTTONWIDTH,BUTTONHEIGHT,"save",   2);
 drawbutton(distancebutton,0,0,BUTTONWIDTH,BUTTONHEIGHT,"distance",-2);
 drawbutton(distancebutton,1+((10-speed)*(BUTTONWIDTH-2))/11,1,
                      (BUTTONWIDTH-2)/11,BUTTONHEIGHT-2,"",2);
 drawbutton(probabutton,0,0,BUTTONWIDTH,BUTTONHEIGHT,"proba",-2);
 drawbutton(probabutton,1+((hbar-1)*(BUTTONWIDTH-2))/10,1,
                      (BUTTONWIDTH-2)/11,BUTTONHEIGHT-2,"",2);
 drawbutton(window,0,playheight+BUTTONHEIGHT,playwidth,BUTTONHEIGHT,
  "Percolation  de premier passage en environnement alatoire",0);
 drawbutton(window,0,playheight+2*BUTTONHEIGHT,playwidth,BUTTONHEIGHT,
  "XCPPP 2.0",0);
 color(4);
 XFillRectangle(display,window,gc,0,playheight,windowwidth,BUTTONHEIGHT);
 //  drawit();
 dessine();
 return;
}

void openwindow(int argc,char **argv)
/* a lot of this is taken from basicwin in the Xlib Programming Manual */
     /*int argc;
       char **argv; */
{char *window_name="XCPPP 2.0";
 char *icon_name="XCPPP";
 long event_mask;
 Pixmap icon_pixmap;
 char *display_name=NULL;
 int i;
# define icon_bitmap_width 16
# define icon_bitmap_height 16
 static const char icon_bitmap_bits[] = {
   0x1f, 0xf8, 0x1f, 0x88, 0x1f, 0x88, 0x1f, 0x88, 0x1f, 0x88, 0x1f, 0xf8,
   0x1f, 0xf8, 0x1f, 0xf8, 0x1f, 0xf8, 0x1f, 0xf8, 0x1f, 0xf8, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff};

/* open up the display */
 if ((display=XOpenDisplay(display_name))==NULL)
  {fprintf(stderr,"%s: cannot connect to X server %s\n",
    progname,XDisplayName(display_name));
   exit(-1);
  }
 screen=DefaultScreen(display);
 cmap=DefaultColormap(display,screen);

 darkcolor=black=BlackPixel(display,screen);
 lightcolor=white=WhitePixel(display,screen);
 translate[0]=white;
 translate[1]=black;
 translate[2]=lightcolor;
 translate[3]=darkcolor;
 for(i=4;i<256;i++)
   translate[i]=translate[i%4]; 
  /* a bunch of colors to play with */
 if (XAllocNamedColor(display,cmap,"salmon",&colorcell,&xcolor))
              darkcolor=colorcell.pixel;
 if (XAllocNamedColor(display,cmap,"wheat",&colorcell,&xcolor))
              lightcolor=colorcell.pixel;
 // if (XAllocNamedColor(display,cmap,"red",&colorcell,&xcolor))
 //              translate[0]=colorcell.pixel;
 if (XAllocNamedColor(display,cmap,"blue",&colorcell,&xcolor))
              translate[1]=colorcell.pixel;
 if (XAllocNamedColor(display,cmap,"green",&colorcell,&xcolor))
              translate[2]=colorcell.pixel;
 if (XAllocNamedColor(display,cmap,"cyan",&colorcell,&xcolor))
              translate[3]=colorcell.pixel;
 if (XAllocNamedColor(display,cmap,"orange",&colorcell,&xcolor))
              translate[4]=colorcell.pixel;
 if (XAllocNamedColor(display,cmap,"purple",&colorcell,&xcolor))
              translate[5]=colorcell.pixel;
 if (XAllocNamedColor(display,cmap,"yellow",&colorcell,&xcolor))
              translate[6]=colorcell.pixel;
 if (XAllocNamedColor(display,cmap,"pink",&colorcell,&xcolor))
              translate[7]=colorcell.pixel;
 if (XAllocNamedColor(display,cmap,"brown",&colorcell,&xcolor))
              translate[8]=colorcell.pixel;
 if (XAllocNamedColor(display,cmap,"grey",&colorcell,&xcolor))
              translate[9]=colorcell.pixel;
 if (XAllocNamedColor(display,cmap,"turquoise",&colorcell,&xcolor))
              translate[10]=colorcell.pixel;
 if (XAllocNamedColor(display,cmap,"gold",&colorcell,&xcolor))
              translate[11]=colorcell.pixel;
 if (XAllocNamedColor(display,cmap,"magenta",&colorcell,&xcolor))
              translate[12]=colorcell.pixel;
 if (XAllocNamedColor(display,cmap,"navy",&colorcell,&xcolor))
              translate[13]=colorcell.pixel;
 if (XAllocNamedColor(display,cmap,"tan",&colorcell,&xcolor))
              translate[14]=colorcell.pixel;
 if (XAllocNamedColor(display,cmap,"violet",&colorcell,&xcolor))
              translate[15]=colorcell.pixel;
 if (XAllocNamedColor(display,cmap,"white",&colorcell,&xcolor))
              translate[16]=colorcell.pixel;
 if (XAllocNamedColor(display,cmap,"black",&colorcell,&xcolor))
              translate[17]=colorcell.pixel;

  /* feel free to type in more colors, I got bored */
 for(i=18;i<256;i++)
   translate[i]=translate[i%18];

    /* make the main window */
 // windowwidth=6*BUTTONWIDTH;
 // windowheight=800;
 windowwidth=cote;
 windowheight=cote+3*BUTTONHEIGHT;
 playwidth=windowwidth;
 playheight=(windowheight-3*BUTTONHEIGHT);
 window=XCreateSimpleWindow(display,RootWindow(display,screen),
   0,0,windowwidth,windowheight,4,translate[14],lightcolor);
    /* make the icon */
 icon_pixmap=XCreateBitmapFromData(display,window,
   icon_bitmap_bits,icon_bitmap_width,icon_bitmap_height);

 size_hints.flags=PPosition | PSize | PMinSize;
 size_hints.min_width=windowwidth;
 size_hints.min_height=300;
 /* this is probably silly, and not really tested, but here goes */
#ifdef X11R3
 size_hints.x=x;
 size_hints.y=y;
 size_hints.width=windowwidth;
 size_hints.height=windowheight;
 XSetStandardProperties(display,window,window_name,icon_name,
    icon_pixmap,argv,argc,&size_hints);
#else
 {XWMHints wm_hints;
  XClassHint class_hints;
  XTextProperty windowName, iconName;
  if (XStringListToTextProperty(&window_name,1,&windowName)==0)
   {fprintf(stderr,"%s: structure allocation for windowName failed.\n"
      ,progname);
    exit(-1);
   }
  if (XStringListToTextProperty(&icon_name,1,&iconName)==0)
   {fprintf(stderr,"%s: structure allocation for iconName failed.\n"
       ,progname);
    exit(-1);
   }
  wm_hints.initial_state=NormalState;
  wm_hints.input=True;
  wm_hints.icon_pixmap=icon_pixmap;
  wm_hints.flags=StateHint|IconPixmapHint|InputHint;
  class_hints.res_name=progname;
  class_hints.res_class="Basicwin";
  XSetWMProperties(display,window,&windowName,&iconName,
       argv,argc,&size_hints,&wm_hints,&class_hints);
 }
#endif

   /* pick the events to look for */
 event_mask=ExposureMask|ButtonPressMask|StructureNotifyMask;
 XSelectInput(display,window,event_mask);
   /* pick font: 9x15 is supposed to almost always be there */
 if ((font=XLoadQueryFont(display,"9x15"))==NULL) 
   if ((font=XLoadQueryFont(display,"fixed"))==NULL)
     {fprintf(stderr,"%s: Sorry, having font problems.\n",progname);
      exit(-1);
     }
 font_height=font->ascent+font->descent;
 font_width=font->max_bounds.width;

  /* make graphics context: */
 gc=XCreateGC(display,window,0,NULL);
 XSetFont(display,gc,font->fid);
 XSetForeground(display,gc,black);
 XSetBackground(display,gc,lightcolor); 

   /* show the window */
 XMapWindow(display,window);
 return;
}

Window makebutton(int xoffset, int yoffset,int xsize,int ysize)
     /*int xoffset,yoffset,xsize,ysize; */
/* Puts button of specified dimensions on window.  Nothing is drawn. */
{Window buttonwindow;
 long event_mask;
 buttonwindow=XCreateSimpleWindow(display,window,xoffset,yoffset,
        xsize,ysize,0,black,lightcolor);
 event_mask=ButtonPressMask|ExposureMask; /* look for mouse-button presses */
 XSelectInput(display,buttonwindow,event_mask);
 XMapWindow(display,buttonwindow);
 return buttonwindow;
}

void makebuttons()
{    /* first destroy any old buttons */
 XDestroySubwindows(display,window);
     /* now make the new buttons */
quitbutton =makebutton(0,windowheight-3*BUTTONHEIGHT,BUTTONWIDTH,BUTTONHEIGHT);
restartbutton=makebutton(BUTTONWIDTH,windowheight-3*BUTTONHEIGHT,BUTTONWIDTH,BUTTONHEIGHT);
pausebutton=makebutton(2*BUTTONWIDTH,windowheight-3*BUTTONHEIGHT,
                       BUTTONWIDTH,BUTTONHEIGHT);
savebutton=makebutton(3*BUTTONWIDTH,windowheight-3*BUTTONHEIGHT,
                       BUTTONWIDTH,BUTTONHEIGHT);
distancebutton=makebutton(windowwidth-BUTTONWIDTH,
                  windowheight-3*BUTTONHEIGHT,BUTTONWIDTH,BUTTONHEIGHT);
probabutton=makebutton(windowwidth-2*BUTTONWIDTH,
                  windowheight-3*BUTTONHEIGHT,BUTTONWIDTH,BUTTONHEIGHT);
 return;
}

void cleanup()
{XUnloadFont(display,font->fid);
 XFreeGC(display,gc); 
 XCloseDisplay(display);
 exit(0);
} 

void sauvegarde()
{ ofstream fichier_out; // Fichier en criture
  Ma_grille.RVB_mem(temps_max);
 if (fond) {Ma_grille.set_convert(temps_max-1,INT_MAX);}
  else {Ma_grille.set_convert(0,INT_MAX);}

// On ouvre le fichier en mode criture "ios::out"

strncpy(chaine, titre.c_str(), 255);
fichier_out.open(chaine, ios::out);

// on crit ce que l'utilisateur a demand
 if (pnm) {
   fichier_out << "P6" << endl;
   fichier_out << "# Fichier gnr par CPPP 1.0" << endl;
   fichier_out  << "# Proba de passage d'une arte : " << p << endl;
   fichier_out  << "# Proba de la valeur dpassant 1 : " << proba << endl;
   //   fichier_out  << "# Temps de passage maximal : " << temps_maxi << endl;
   //   fichier_out  << "# Temps de passage minimal : " << temps_mini << endl;
   fichier_out  << "# Germe : " << germe << endl;
   fichier_out  << "# Taille du demi-cran : " << demi << endl;
   fichier_out << cote << " " << cote << endl << "255" << endl;
   fichier_out << Ma_grille; 
 }
 fichier_out.close();
}

int main(int argc,char **argv)
     /*int argc;
       char **argv; */
{  

  bool help;
  argstream as(argc, argv);
as >>parameter('g',"germe",germe,"germe du gnrateur alatoire",false)
>>parameter('a',"alea",proba," Proba de la valeur depassant 1",false)
>>parameter('c',"couleur",couleur,"couleur de la deuxime particule",false)
>>parameter('p',"proba",p," Proba de passage d'une arte",false)
>>parameter('d',"demi",demi," taille du demi ecran",false)
>>parameter('v',"vitesse",vitesse," plus grande vitesse",false)
>>parameter('r',"r1",facteur[1],"Facteur de ralentissement du type 1",false)
>>parameter('s',"r2",facteur[2],"Facteur de ralentissement du type 2",false)
>>parameter('e',"ecart",ecart,"Ecart entre les sources",false)
>>parameter('f',"fichier",titre," fichier de sortie",false)
 >>option ('P',"PN",pnm,"Image dans un fichier pnm")
 >>option ('F',"fond",fond,"Fond en blanc")
 >>option ('C',"sortie_couleur",sortie_couleur,"Couleur finale dans le fichier de sortie")
 >>option ('T',"sortie_temps",sortie_temps,"Temps final dans le fichier de sortie")
>>option ('D',"sortie_diff",sortie_diff,"Diffrentiel de temps dans le fichier de sortie")
>>option('h',"help",help,"Affiche cette aide");
if (help)
{
cout <<"XCPPP 2.0"<< endl;
cout <<as.usage()<<endl;
}
  
else
  {


// tranche si les options sont incompatibles

 if (!( pnm ^ ( sortie_couleur | sortie_temps | sortie_diff)))
   {sortie_couleur=0;
   sortie_temps=0;
   sortie_diff=0;
   pnm=1;
   }

  cote=calcul_cote(demi);
  Ma_grille.mem(cote);
  srandom(germe);
  initialisation();

int k;
 double psipeg,w;
 unsigned int width, height;
 XEvent report;
 progname=argv[0];
 openwindow(argc,argv);
 makebuttons();
  /* set up trig stuff */

 // initialisation
   
  /* loop forever, looking for events */
 while(1)
  
     {
       if ((0==XPending(display))&&(0==paused))
    {
      //if (delay) 
/* don't update yet */
      //       {delay--;
        /* this use of select() seems a kludge to me; 
           why can't usleep() be more standard? */
      //  timeout.tv_sec=0;
      //  timeout.tv_usec=50000; /* .05 sec per delay unit */
      // select(0,NULL,NULL,NULL,&timeout); 
      //     }
      //      else
        {delay=speed;
        etape();
      }
     }
        else
    {XNextEvent(display,&report); 
     switch (report.type)
      {case Expose: /* the window is exposed and needs to be redrawn */
        if ((report.xexpose.window)!=window) break; /* cuts down flashing,
           but you might remove this line if things aren't being redrawn */
        if (report.xexpose.count!=0) break; /* more in queue, wait for them */
        repaint();  
        break;
       case ConfigureNotify: /* the window has been resized */
        width=report.xconfigure.width;
        height=report.xconfigure.height;
        if ((width<size_hints.min_width)||(height<size_hints.min_height))
            {fprintf(stderr,"%s: window too small to proceed.\n",progname);
             cleanup();
            } 
        else if ((width!=windowwidth)||(height!=windowheight))
            {windowwidth=width;
             windowheight=height;
             playwidth=windowwidth;
             playheight=(windowheight-3*BUTTONHEIGHT);
             makebuttons();
            } 
        break; 
       case ButtonPress:  /* which button was pressed? */
        if (report.xbutton.window==quitbutton)
             cleanup();
        else if (report.xbutton.window==restartbutton)
             recommence();
        else if (report.xbutton.window==savebutton)
             sauvegarde();
        else if (report.xbutton.window==pausebutton)
            {paused=1-paused;
             drawbutton(pausebutton,0,0,BUTTONWIDTH,BUTTONHEIGHT,
			"pause",2-4*paused);}
        else if (report.xbutton.window==distancebutton)
          {  /* reset speed */
           speed=10-(11*report.xbutton.x)/BUTTONWIDTH;
           if (speed<0) speed=0;
           if (speed>10) speed=10;
           delay=speed;
           drawbutton(distancebutton,0,0,BUTTONWIDTH,BUTTONHEIGHT,"distance",-2);
           drawbutton(distancebutton,1+((10-speed)*(BUTTONWIDTH-2))/11,1,
                      (BUTTONWIDTH-2)/11,BUTTONHEIGHT-2,"",2);
           ecart=((10-speed)*demi)/20;
          }
        else if (report.xbutton.window==probabutton)
          {  /* reset hbar */
           hbar=1+(10*report.xbutton.x)/BUTTONWIDTH;
           if (hbar<1) hbar=1;
           if (hbar>10) hbar=10;
	   //      cout << float(hbar)*0.1;
            p=0.4+float(hbar)*0.06;
           drawbutton(probabutton,0,0,BUTTONWIDTH,BUTTONHEIGHT,"proba",-2);
           drawbutton(probabutton,1+((hbar-1)*(BUTTONWIDTH-2))/10,1,
                      (BUTTONWIDTH-2)/11,BUTTONHEIGHT-2,"",2);
          }
        break;
       default:
        break;
      } /* end of switch */
    } /* end of if XPending */
  } /* end of while(1) */
  }
} /* end of main */








